<?php
namespace Claromentis\People\Controller\Rest;

$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("_3682611b493" . "2733eb97863f" . "a0b396700" => base64_decode("RXJyb3IgdXBkYXRpbmcgcm9s" . "ZQ=="), "_3efc5ba7bf51ca70907f5e65ab60" . "2ec1" => base64_decode("SW50ZXJuYWwgU2VydmVyIEVyc" . "m9y"), "_aabddb8e5540f5" . "96ece10005c132c" . "6b6" => base64_decode("RXJyb3Igc2V0dGluZyByb" . "2xlIHVzZXJz"), "_c894747360c6ec" . "5bd8169530eaf9c" . "473" => base64_decode("QmFkIFJlcXV" . "lc3Q="), "_94c782c8180766e1ff1" . "870975a93053d" => base64_decode("Um9sZSBub3QgZm9" . "1bmQ="), "_0ef58d1ad10b6ac762ed9c" . "5940c6feb7" => base64_decode("RXJyb3IgY3JlYXRpbmcg" . "cm9sZQ=="), "_67b69c042916369a28" . "c74a7c8b278522" => base64_decode("RXJyb3Ig" . "ZGVsZXRp" . "bmcgcm9s" . "ZQ=="), "_a4a1018258adabb74e7b04836d8d7e3" . "b" => base64_decode("Tm90I" . "EZvdW" . "5k"), "_79bd87060993ff622ef212" . "c1e8b6a79a" => base64_decode("Rm9yYml" . "kZGVu"), "role_" . "id" => base64_decode("cm9sZV9pZ" . "A=="), "_25fb31f00b26bde87effd4" . "759e283d9f" => base64_decode("cm9sZV9pZ" . "HM="));
use Analogue\ORM\Exceptions\MappingException;


use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\People\Exception\NotFoundException;
use Claromentis\People\Exception\PermissionException;
use Claromentis\People\Exception\ValidationException;
use Claromentis\People\Filter\RoleFilter;
use Claromentis\People\Filter\UserFilter;
use Claromentis\People\RestFormatter;
use Claromentis\People\UseCase\CreateRole;
use Claromentis\People\UseCase\DeleteRole;
use Claromentis\People\UseCase\GetRole;
use Claromentis\People\UseCase\GetRoles;
use Claromentis\People\UseCase\GetRoleUsers;
use Claromentis\People\UseCase\SetRoleUsers;
use Claromentis\People\UseCase\UpdateRole;
use InvalidArgumentException;
use Psr\Http\Message\ServerRequestInterface as Request;
use RestExBadRequest;
use RestExError;
use RestExForbidden;
use RestExNotFound;
use UnexpectedValueException;






class RoleController extends AbstractController
{
    
    
    
    
    protected $formatter;
    
    
    
    
    protected $get_role;
    
    
    
    
    protected $get_roles;
    
    
    
    
    protected $create_role;
    
    
    
    
    protected $update_role;
    
    
    
    
    protected $delete_role;
    
    
    
    
    protected $get_role_users;
    
    
    
    
    protected $set_role_users;
    
    
    
    
    
    
    
    
    
    
    
    public function __construct(RestFormatter $formatter, GetRole $get_role, GetRoles $get_roles, CreateRole $create_role, UpdateRole $update_role, DeleteRole $delete_role, GetRoleUsers $get_role_users, SetRoleUsers $set_role_users)
    {
        $this->formatter = $formatter;
        $this->get_role = $get_role;
        $this->get_roles = $get_roles;
        $this->create_role = $create_role;
        $this->update_role = $update_role;
        $this->delete_role = $delete_role;
        $this->get_role_users = $get_role_users;
        $this->set_role_users = $set_role_users;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public function GetOne(SecurityContext $context, Request $request, $role_id)
    {
        $use_case = $this->get_role;
        try {
            $_03e9164d0a343b742df4793268b80767 = new RoleFilter($context);
            $_03e9164d0a343b742df4793268b80767->Fill($this->formatter->GetRequestParams($request, $_03e9164d0a343b742df4793268b80767->GetDefaults()));
            $_d1071a032215f0eb5c4a8ef175f7049d = $use_case->GetRole($context, $role_id, $_03e9164d0a343b742df4793268b80767);
            return new JsonPrettyResponse($this->formatter->FormatRole($_d1071a032215f0eb5c4a8ef175f7049d, $_03e9164d0a343b742df4793268b80767));
        } catch (InvalidArgumentException|ValidationException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_c894747360c6ec5bd8169530eaf9c47" . "3"], $exception);
        } catch (NotFoundException $exception) {
            throw new RestExNotFound($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_a4a1018258adab" . "b74e7b04836d8d7" . "e3b"], $exception);
        } catch (PermissionException $exception) {
            throw new RestExForbidden($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_79bd870" . "60993ff6" . "22ef212c" . "1e8b6a79" . "a"], $exception);
        }
    }
    
    
    
    
    
    
    
    
    
    public function GetList(SecurityContext $context, Request $request)
    {
        try {
            $_03e9164d0a343b742df4793268b80767 = new RoleFilter($context);
            $_03e9164d0a343b742df4793268b80767->Fill($this->formatter->GetRequestParams($request, $_03e9164d0a343b742df4793268b80767->GetDefaults()));
            [$_23ab4dd81b6c619f47099ef7c2485a12, $total] = $this->get_roles->GetRoles($_03e9164d0a343b742df4793268b80767);
            $response = $this->formatter->Paginate($request, $this->formatter->FormatRoles($_23ab4dd81b6c619f47099ef7c2485a12, $_03e9164d0a343b742df4793268b80767), $_03e9164d0a343b742df4793268b80767->GetChanged(), $total);
        } catch (InvalidArgumentException|UnexpectedValueException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_c894747360c6ec5bd8169530eaf9c4" . "73"], $exception);
        }
        return new JsonPrettyResponse($response);
    }
    
    
    
    
    
    
    
    
    
    
    
    public function Post(SecurityContext $context, Request $request)
    {
        try {
            $_d1071a032215f0eb5c4a8ef175f7049d = $this->create_role->CreateRole($context, $this->formatter->GetJson($request));
        } catch (PermissionException $exception) {
            throw new RestExForbidden($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_79bd87060993ff622" . "ef212c1e8b6a79a"], $exception);
        } catch (ValidationException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_c894747360c6ec5bd816953" . "0eaf9c473"], $exception);
        } catch (MappingException $exception) {
            throw new RestExError($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_0ef58d1ad10b6ac762ed9c5940" . "c6feb7"], 500, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_3efc5ba7bf51ca7090" . "7f5e65ab602ec1"], $exception);
        } catch (InvalidArgumentException|UnexpectedValueException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_c894747360c6ec5bd8169530eaf9c47" . "3"], $exception);
        }
        return new JsonPrettyResponse($this->formatter->FormatRole($_d1071a032215f0eb5c4a8ef175f7049d), 201);
    }
    
    
    
    
    
    
    
    
    
    
    
    public function Put(SecurityContext $context, Request $request)
    {
        try {
            $_d1071a032215f0eb5c4a8ef175f7049d = $this->update_role->UpdateRole($context, $this->formatter->GetRequestParam($request, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["role_i" . "d"]), $this->formatter->GetJson($request));
            return new JsonPrettyResponse($this->formatter->FormatRole($_d1071a032215f0eb5c4a8ef175f7049d));
        } catch (NotFoundException $exception) {
            throw new RestExNotFound($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_a4a1018258adabb" . "74e7b04836d8d7e3" . "b"], $exception);
        } catch (PermissionException $exception) {
            throw new RestExForbidden($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_79bd87060993f" . "f622ef212c1e8b" . "6a79a"], $exception);
        } catch (ValidationException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_c894747360c6ec5bd8169530" . "eaf9c473"], $exception);
        } catch (MappingException $exception) {
            throw new RestExError($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_3682611b4932733eb97863f" . "a0b396700"], 500, $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_3efc5ba7bf" . "51ca70907f5" . "e65ab602ec1"], $exception);
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    public function Delete(SecurityContext $context, Request $request)
    {
        try {
            $this->delete_role->DeleteRole($context, $this->formatter->GetRequestParam($request, $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["role" . "_id"]));
        } catch (NotFoundException $exception) {
            throw new RestExNotFound($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_a4a1018258adabb74e7b04836d8d" . "7e3b"], $exception);
        } catch (PermissionException $exception) {
            throw new RestExForbidden($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_79bd87060993ff622ef21" . "2c1e8b6a79a"], $exception);
        } catch (MappingException $exception) {
            throw new RestExError($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_67b69c042916369a28c74a7c8" . "b278522"], 500, $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_3efc5ba7bf51ca70907f5e65ab" . "602ec1"], $exception);
        }
        return new JsonPrettyResponse(null, 204);
        
        
    }
    
    
    
    
    
    
    
    
    
    
    
    public function GetUsers(SecurityContext $context, Request $request)
    {
        try {
            $_03e9164d0a343b742df4793268b80767 = new UserFilter($context);
            $_03e9164d0a343b742df4793268b80767->Fill($this->formatter->GetRequestParams($request, $_03e9164d0a343b742df4793268b80767->GetDefaults()));
            list($_e4543e131c67c631b14751cc849d1310, $total) = $this->get_role_users->GetRoleUsers($context, $this->formatter->GetRequestParam($request, $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["role" . "_id"]), $_03e9164d0a343b742df4793268b80767);
            $response = $this->formatter->Paginate($request, $this->formatter->FormatUsers($_e4543e131c67c631b14751cc849d1310, $_03e9164d0a343b742df4793268b80767), $_03e9164d0a343b742df4793268b80767->GetChangedWithout([$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_25fb31f00b26bde" . "87effd4759e283d9" . "f"]]), $total);
        } catch (NotFoundException $exception) {
            throw new RestExNotFound($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_94c782c8180766e1ff1870975a9305" . "3d"], $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_a4a1018258adabb74e7b04836d8d7e" . "3b"], $exception);
        } catch (PermissionException $exception) {
            throw new RestExForbidden($exception->getMessage(), $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_79bd87060993ff" . "622ef212c1e8b6a" . "79a"], $exception);
        } catch (InvalidArgumentException|UnexpectedValueException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_c894747360c6" . "ec5bd8169530e" . "af9c473"], $exception);
        }
        return new JsonPrettyResponse($response);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public function PutUsers(SecurityContext $context, Request $request)
    {
        try {
            $_e4543e131c67c631b14751cc849d1310 = $this->set_role_users->SetRoleUsers($context, $this->formatter->GetRequestParam($request, $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["role" . "_id"]), $this->formatter->PluckRequestIds($request));
            return new JsonPrettyResponse($this->formatter->FormatUsers($_e4543e131c67c631b14751cc849d1310));
        } catch (NotFoundException $exception) {
            throw new RestExNotFound($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_a4a1018258adabb74e" . "7b04836d8d7e3b"], $exception);
        } catch (PermissionException $exception) {
            throw new RestExForbidden($exception->getMessage(), $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_79bd87060993ff622ef212c" . "1e8b6a79a"], $exception);
        } catch (ValidationException $exception) {
            throw new RestExBadRequest($exception->getMessage(), $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_c894747360c6ec5b" . "d8169530eaf9c473"], $exception);
        } catch (MappingException $exception) {
            throw new RestExError($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_aabddb8" . "e5540f59" . "6ece1000" . "5c132c6b" . "6"], 500, $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_3efc5ba7bf51ca70907f5e" . "65ab602ec1"], $exception);
        }
    }
}